read_secrets:
  image:
    name: alpine:latest

  script:
    - apk add --update curl jq

    - "export VAULT_LOGIN_OUTPUT=$(curl --request POST --data '{\"role\": \"kv-demo\", \"jwt\": \"'$CI_JOB_JWT'\"}' $VAULT_SERVER_URL/v1/auth/jwt/login)"
    - export VAULT_TOKEN=$(echo $VAULT_LOGIN_OUTPUT | jq -r '.auth.client_token')
    - echo $VAULT_TOKEN

    # Now use the VAULT_TOKEN to read the key and store it in an environment variable

    # List secrets in the kv Secrets Engine at path /kv
    - "export SECRETS_LIST=$(curl -H \"X-Vault-Token: $VAULT_TOKEN\" --request LIST $VAULT_ADDR/v1/kv/metadata)"
    - export SECRETS=$(echo $SECRETS_LIST | jq -r '.data.keys')
    - echo $SECRETS

    # Retrieve key from secret
    - "export KV_DATA=$(curl -H \"X-Vault-Token: $VAULT_TOKEN\" $VAULT_ADDR/v1/kv/data/demo)" 
    - echo $KV_DATA
    - export PASSWORD=$(echo $KV_DATA | jq -r '.data.data.password')
    - echo $PASSWORD
